-- Ordered pairs iterator.

function _G.opairs( tbl, sort )
	local Keys = { }

	-- Generate a temp table of keys.
	for key in pairs( tbl ) do
		table.insert(Keys, key)
	end

	local sorter = sort or function(a,b) return a<b end

	-- Sort the keys.
	table.sort( Keys, sorter )


	-- Return an iterator to step over sorted keys
	local ix = 0
	return function()
		ix = ix + 1
		local key = Keys[ix]
		if key then return key,tbl[key] end
	end
end
