-- Reputation Reference plugin by David Down
-- coding: utf-8 'ä
import "Turbine.Gameplay"

function print(text) Turbine.Shell.WriteLine("<rgb=#00FFFF>RR:</rgb> "..text) end

import "Vinny.RepRef.RR_Data"

local xpat  = "^<Examine:IIDDID:0x0%x+:0x700(%x+)>%[(.+)%]<\\Examine>$"
local xpat2 = "^<ExamineItemInstance:ItemInfo:(.+)>%[(.-)%]<\\ExamineItemInstance>$"
local xlink = "<Examine:IIDDID:0x0000000000000000:0x700%s>[%s]<\\Examine>"
local RRv = Plugins["RepRef"]:GetVersion()
print("RepRef "..RRv.." initialized.")

player = Turbine.Gameplay.LocalPlayer.GetInstance()
local ml

import "Vinny.RepRef.RR_Window"
RR_window = RR_Window()
RR_Opt = Turbine.PluginData.Load(Turbine.DataScope.Server,"RepRef_Opt")
if RR_Opt and RR_Opt.auto then
	RR_window:SetPosition(RR_Opt.auto.x, RR_Opt.auto.y)
	RR_window:SetVisible( true )
end

function InAt(rg,loc)
	return #loc>2 and " at "..loc or " in "..rg[loc].n
end

function Barter(rg,b)
	if not b or not b.id then return end
	if rg~=b then
		local str = ItemCode.R[b.c]
		print("Buy "..str.." recipes from "..b.n..InAt(rg,b.l))
	else print("Reputation items that can be used:") end
--	if not b.id then return end
	for i,id in ipairs(b.id) do
		local t = RepID[id]
		local link = string.format(xlink,id,t.n)
		if t.r then
			link = link.." from "..string.format(xlink,t.r,t.n.." Recipe")
		end
		local s = "."
		if t.q then s = " (Quest["..t.q.."])." end
		print("> "..link.." gives "..t.p.." reputation"..s)
	end
end

function Vendor(rg,v)
	if not v then return end
	print(v.n..InAt(rg,v.l).." sells:")
	for i,r in ipairs({'u','q','f','a','k'}) do
		local t = v[r]
		if t then
			local str = ''
			for i2,id in ipairs(t) do
				if not ml or not ItemID[id].l or ItemID[id].l<=ml then
					if #str>0 then str = str..", " end
					str = str..string.format(xlink,id,ItemID[id].n)
				end
			end
			if str~='' then print(Standing[r]..": "..str) end
		end
	end
end

RR_Command = Turbine.ShellCommand()
local help_text = "rr <link> (Get rep. info for an item)"
function RR_Command:GetShortHelp() return help_text end
function RR_Command:GetHelp() return help_text end

function RR_Command:Execute( cmd,args,lvl )
	if args=="help" then
		print(help_details)
		return
	end
	if args=="factions" then
		print("<rgb=#00FF00>Reputation factions:</rgb>")
		local ix = {}
		for id in pairs(Faction) do
		    table.insert(ix,id)
		end
		table.sort(ix)
		for i,id in ipairs(ix) do
			local t = Faction[id]
			print(string.format("%s: %s at %s in %s",id, t.n, t.s, t.z))
		end
		return
	end
	if args=="types" then
		print("<rgb=#00FF00>Vendor item types:</rgb>")
		local ix = {}
		for id in pairs(ItemCode) do table.insert(ix,id) end
		table.sort(ix)
		for i,id in ipairs(ix) do
			local group = ItemCode[id]
			if type(group)=="table" then
				local list,gname = {}
				for c,name in pairs(group) do
					if c=="" then gname = name
					else table.insert(list,name) end
				end
				table.sort(list)
				local str = ""
				for ii,name in ipairs(list) do
					if #str>0 then str = str..", " end
					str = str..name
				end
				print(gname..": "..str)
			else print(group) end
		end
		return
	end
	if lvl and lvl~='' then
		ml = tonumber(lvl)
		if not ml or ml<1 or ml>75 then
			print("Error, invalid level.")
			return
		end
	else ml = nil end
	local code = ItemType[args]
	if code then
		local l = #code
		print("<rgb=#00FF00>"..args.." items sold by reputation vendors:</rgb>")
		print("code="..code)
		for id,t in pairs(ItemID) do
			if string.sub(t.t,1,l)==code then
				if not ml or not t.l or t.l<=ml then
					local link = ": "..string.format(xlink,id,t.n)
					print("("..t.f..") "..Standing[t.r]..link)
				end
			end
		end
		return
	end
	local rg = Faction[args]
	if rg then
		if cmd=="rrv" then
			print("<rgb=#00FF00>"..rg.n.." vendors at "..rg.s.." in "..rg.z..":</rgb>")
			Vendor(rg,rg.b)
			Vendor(rg,rg.ds)
			Vendor(rg,rg.v)
			Vendor(rg,rg.v2)
			return
		end
		print("<rgb=#00FF00>"..rg.n.." at "..rg.s.." in "..rg.z..":</rgb>")
		if rg.dt then
			local str = "Daily Tasks @ "
			for i,name in ipairs(rg.dt) do
				if i>1 then str = str..", " end
				str = str..name
			end
			print(str)
		end
		local i = rg.i2
		if i then print("Enter "..i.n.." at "..i.l) end
		local i = rg.i
		if i then
			local s = i.r and "Friends can e" or "E"
			print(s.."nter "..i.n..InAt(rg,i.l))
		end
		local q = rg.q
		if q then
			local loc = q.l=="i" and rg.i.n or q.l
			print(string.format("Into-quest: [%d] %s, from %s @ %s in %s",
						q.q, q.t, q.n, loc, q.s ))
		end
		if rg.dq then
			local str = ""
			for name,lc in pairs(rg.dq) do
				if #str>0 then str = str..", " end
				local loc = lc=="i2" and rg.i2.n or lc
				str = str..name.."@"..loc
			end
			print("Daily reputation quests are available from: "..str)
		end
		if rg.td then
			print("Friends get 10% travel discount at "..rg.td)
		end
		local s = rg.v
		if s then print("Shop with "..s.n..InAt(rg,s.l)) end
		local s = rg.v2
		if s then print("Shop with "..s.n..InAt(rg,s.l)) end
		local s = rg.vc
		if s then print("Buy "..ItemCode.R[s.c].." recipes from "..s.n..InAt(rg,s.l)) end
		local s = rg.ds
		if s then print("Ally 5% off supplier "..s.n..InAt(rg,s.l)) end
		Barter(rg,rg)
		Barter(rg,rg.bc)
		return
	end
    local id,name,x = args:match(xpat)
	if not id then
		x,name = args:match(xpat2)
		if not name then
			local nm = args:lower()
			for ix,t in pairs(ItemID) do
				if nm==t.n:lower() then id=ix break end
			end
		elseif name:match("^(%d+) ") then
			print("<rgb=#FF6040>Error: Only single items can be identified.</rgb>")
			return
		else nm = name:lower() end		-- look for name match
		if not id then
			for ix,t in pairs(RepID) do
				if nm==t.n:lower() then id=ix break end
			end
		end
		if name and not id then
			print("Unkmown item, "..name)
			return
		end
	end
	if id then
		local i,i2 = RepID[id],ItemID[id]
		if i then
			local link = string.format(xlink,id,i.n)
			print(link.." gives "..i.p.." reputation with "..Faction[i.f].n)
			local prof = ItemCode.R[i.t]
			if prof then
				link = string.format(xlink,i.r,name.." Recipe")
				print(prof.."s craft it from "..link)
			elseif i.t=="D" then print("It is a loot drop.")
			else print("It is a quest reward.") end
			if i.q then
				print("Required quest: ["..i.q.."] "..i.n.." - Introduction")
			end
		elseif i2 then
			local link = string.format(xlink,id,i2.n)
			local f = Faction[i2.f]
			local v = f[i2.v or "v"]
			print(link.." is sold by "..v.n..InAt(f,v.l))
			print("It requires "..Standing[i2.r].." standing with "..f.n)
		else print("Unknown: "..name.." = "..id) end
		return
	end
    print(help_text)
end

Turbine.Shell.AddCommand( "rr;rrv",RR_Command )

-- Options panel
OP = Turbine.UI.Control()
OP:SetBackColor( Turbine.UI.Color(0.0, 0.0, 0.1) )
OP:SetSize( 600, 600 )

local autoBox = Turbine.UI.Lotro.CheckBox()
autoBox:SetText( " Auto-open window" )
autoBox:SetSize( 150, 22 )
autoBox:SetPosition( 10, 10 )
autoBox:SetParent( OP )
if RR_Opt and RR_Opt.auto then autoBox:SetChecked(true) end

autoBox.CheckedChanged = function( sender, args )
	if not RR_Opt then RR_Opt = {} end
	RR_Opt.auto = sender:IsChecked()
	if RR_Opt.auto then
		local x,y = RR_window:GetPosition()
		RR_Opt.auto = { x=x, y=y }
		print("Saved window position.")
	end
	print((RR_Opt.auto and "En" or "Dis").."abled Auto-open.")
	Turbine.PluginData.Save(Turbine.DataScope.Server,"RepRef_Opt",RR_Opt)
end

plugin.GetOptionsPanel = function( self ) return OP end

